<template>
  <v-container align-content-center justify-center fill-height>
    <v-card>
      <!-- Title -->
      <v-card-title>
        <v-list two-line class="pa-0 ma-0">
          <v-list-tile avatar>
            <v-list-tile-avatar>
              <slot name="avatar"/>
            </v-list-tile-avatar>
            <v-list-tile-content>
              <v-list-tile-title>
                <slot name="title"/>
              </v-list-tile-title>
              <v-list-tile-sub-title>
                <slot name="subtitle"/>
              </v-list-tile-sub-title>
            </v-list-tile-content>
            <v-spacer/>
          </v-list-tile>
        </v-list>
      </v-card-title>
      <v-divider/>
      <!-- Formulary -->
      <v-container>
        <v-form ref="form" @submit.prevent="submitForm">
          <v-list subheader class="pa-0 ma-0">
            <slot/>
            <v-btn type="submit" :loading="loading" :color="submitColor">Save</v-btn>
          </v-list>
        </v-form>
      </v-container>
    </v-card>
    <!-- Modals -->
    <v-snackbar v-model="snackbar" :color="error && error.color" :timeout="error && error.timeout">
      {{ error && error.message }}
      <v-btn dark flat @click="snackbar = false">Ok</v-btn>
    </v-snackbar>
  </v-container>
</template>

<script>
export default {
  props: {
    save: {
      type: Function,
      default: null
    }
  },
  data() {
    return {
      // Control
      submitColor: null,
      loading: false,
      error: null,
      snackbar: null
    };
  },
  methods: {
    async submitForm() {
      if (!this.$refs.form.validate()) {
        this.submitColor = "error";
        return;
      }

      try {
        this.loading = true;
        if (this.save) await this.save();
        this.submitColor = "success";
      } catch (e) {
        console.error(e);
        this.submitColor = "error";
        if (e.networkError)
          this.error = {
            color: "error",
            message: "An error has ocurred"
          };
        else if (e.graphQLErrors)
          this.error = {
            color: "warning",
            message: e.graphQLErrors[0].message || "Error in the request"
          };
        else
          this.error = {
            color: "error",
            message: "An error has ocurred"
          };
        this.snackbar = true;
      } finally {
        this.loading = false;
        setTimeout(() => (this.submitColor = null), 1000);
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.root,
form {
  width: 100%;
  height: 100%;
}
</style>
